
% Exemplos de resposta em frequencia

R1 = 6.8e3 ; 
C1 = 22e-9 ; 

R2 = 4e3 ; 
C2 = 22e-9 ; 
L2 = 640e-3 ; 

% 1a. ordem 

tau = R1*C1 ;

num1 = 1 ; 
den1 = [ tau 1 ] ; 

ord1 = tf(num1,den1) ; 

% 2a. ordem 

wn = sqrt(inv(L2*C2)) ;
zeta = R2/(2*L2*wn) ; 

num2 = wn^2 ; 
den2 = [ 1 2*zeta*wn wn^2 ] ; 

ord2 = tf(num2,den2) ; 

% 3a. ordem 

ord3 = series(ord1,ord2) ; 

% Anlise da estabilidade relativa

figure(1) 
margin(ord3) 

% Anlise do erro de regime

ord3mf = feedback(ord3,1)

figure(2) 
step(ord3mf) 

pause

% Controlador proporcional para reduzir o erro de regime

K1 = 2.0732275 ; 

ord3k1 = series(K1,ord3)

ord3k1mf = feedback(ord3k1,1)

figure(3) 
step(ord3k1mf,0.02) 

% Anlise da estabilidade relativa

figure(4) 
margin(ord3k1) 

pause

% Projeto do compensador de fase 

Kbar = 9 ; 

ord3kbar = series(Kbar,ord3)

figure(5) 
margin(ord3kbar) 

pause

phimax = 51.9*pi/180 ; 

alpha = (1 - sin(phimax))/(1 + sin(phimax)) ; 

GwmaxdB = -20*log10(inv(sqrt(alpha))) ; 

wmax = 2.41e4 ; 

T = inv(sqrt(alpha)*wmax) ; 

Kc = Kbar/alpha ; 

numc = [ Kc Kc/T ] ; 
denc = [ 1 inv(alpha*T) ] ; 

Gc = tf(numc,denc) ; 

figure(6)
bode(Gc)

pause

ord3c = series(Gc,ord3) ; 

figure(7)
margin(ord3c) 

pause

ord3cg = series(0.15*Gc,ord3c) ; 

figure(8)
margin(ord3cg) 

pause

% Anlise da estabilidade absoluta

ord3cgmf = feedback(ord3cg,1) ; 

% Anlise do erro de regime

figure(9) 
step(ord3cgmf) 
